
body.article{
  background: var(--clr-back);
}

/* LAYOUTS
  ========================================================================== */

/* types of layouts */
body.article--media{
  display: grid;
  grid-template-columns: min(60rem, 50%) 1fr;
}
body.article--long{
  display: grid;
  grid-template-columns: min(28rem, 50%) 1fr;
}

body > section{
  /* inside of the grid should be put like that
  to ensure that the 1fr is not going to overflow */
  overflow: auto;
  max-width: 100%;
}

/* separate scroll on media and toc */ 
.full-h-sticky{
  position: sticky;
  top: 0;
  height: 100vh;
  overflow-y: auto;
  overflow-x: hidden;
}

body.article--long .article__aside{
  display: flex;
  flex-direction: column;
}
body.article--long  .article__header,
body.article--long  .article__footer{
  border-right: var(--border);
}
body.article--long  .article__footer{
  flex-grow: 1;
}
body.article--long .button-link{
  margin-right: 0;
}

/* text itself has max size */
body.article--long .article__content{
  max-width: min(42rem, 100%);
  margin: 0 auto;
  margin-top: calc(var(--lh) * 2);
  margin-bottom: calc(var(--lh) * 2);
}

@media (max-width: 60rem) {

  /* make it sticky */
  .article__nav{
    position: sticky;
    top: 0;
    z-index: 999;
  }
  .article__header{
    position: sticky;
    top: calc(var(--ui-height) - var(--border-width));
    z-index: 999;

    max-height: calc(100vh - calc(2 * var(--lh)));
    overflow: scroll;
    box-sizing: border-box;
  }


  body.article--long .button-link{
    margin-right: 0;
  }

  body.article--media,
  body.article--long{
    /* back in one column */
    grid-template-columns: 1fr;
    grid-template-rows: auto 1fr;
  }

  /* reset stickyness */
  .full-h-sticky{
    position: revert;
    height: revert;
    display: contents !important;
  }

  body.article--long  .article__header,
  body.article--long  .article__footer{
    border-right: none;
  }
  .article__header{
    padding-bottom: 0;
  }

  footer{
    display: none;
  }

}
  
/* GENERAL
  ========================================================================== */

.article__nav{
  border: none;
}
.article__nav > a{
  display: block;
  height: var(--ui-height);

  border: var(--border);
  margin: calc(-1 * var(--border-width));

  box-sizing: border-box;

  position: relative;
  z-index: 1001;

  display: flex;
  justify-content: space-between;
  align-items: center;
}


.article__media{
  box-sizing: border-box;
}
.article__text > *:not(:last-child),
.article__aside > *:not(:last-child){
  border-bottom: var(--border);
}

footer.article__footer{
  color: var(--clr-fade);
}

.article__title,
.article .date,
.article__toc,
.article__short{
  margin: calc(var(--lh) * 0.5) 0;
  display: block;
}
.article__toc{
  margin-bottom: 0;
}

.article__nav{
  background-color: var(--clr-back);
}
.article__media{
  background: var(--clr-dark-back);
  border-left: var(--border);

  display: grid;
  grid-gap: var(--lh);
  grid-template-columns: repeat(auto-fit, minmax(250px, 1fr));
  grid-template-rows: min-content;
  grid-auto-rows: min-content;

  align-items: center;
}
.article__media a:hover{
  outline: calc(var(--border-width) * 2) solid var(--clr-link-local);
}

@media screen and (max-width: 60rem) {
  .article__media {
    position: sticky;
    bottom: 0;
    border-left: 0;
    border-top: var(--border);
    height: 30vh;
    display: flex !important;
    overflow: auto;
  }
  .article__media > *{
    height: 100%;
  }
  .article__media img{
    max-width: none;
    height: 100%;
  }
}
@media screen and (max-width: 36rem) {
  .article__nav a{
    border-left: 0;
    border-right: 0;
    margin-left: 0;
    margin-right: 0;
  }
  .article__media{
    height: 33vh;
  }
  .article__content > *:first-child{
    margin-top: 0;
  }
  .article__header .mobile-details summary{
    margin-top: calc(var(--lh) * 0.5);
  }
  .article__header{
    /* padding-top: calc(var(--lh) * 0.5); */
  }
  .article__title{
    text-align: center;
  }
  .article__content{
    margin-top: 0 !important;
  }
}

/* HEADER STYLES
  ========================================================================== */

h1{
  font-size: var(--fs-h-plus);
}

.article__text h2{
  text-align: center;
  font-size: var(--fs-h-plus);
}
.article__text h3{
  font-size: var(--fs-h);
  text-decoration: var(--underline);
  counter-set: h4 0;
}
.article__text h4{
  text-decoration: var(--underline);
}

/* modification vertical rythm */
.article__text h2{
  margin-bottom: calc(var(--lh) * 2);
}


/* ARTICLES COUNTERS
  ========================================================================== */

/* .article__content{
  counter-set: h2 0;
}
.article__content h2{
  counter-set: h3 0;
}
.article__content h2::before{
  counter-increment: h2;
  content: counter(h2) ". ";
}
.article__content h3{
  counter-set: h4 0;
}
.article__content h3::before{
  counter-increment: h3;
  content: counter(h2) "." counter(h3) ". ";
}
.article__content h4{
  counter-set: h5 0;
}
.article__content h4::before{
  counter-increment: h4;
  content: counter(h2) "." counter(h3) "." counter(h4) ". ";
}
.article__content h5{
  counter-set: h6 0;
}
.article__content h5::before{
  counter-increment: h5;
  content: counter(h2) "." counter(h3) "." counter(h4) ". " counter(h5) ". ";
}
.article__content h6::before{
  counter-increment: h6;
  content: counter(h2) "." counter(h3) "." counter(h4) ". " counter(h5) ". " counter(h6) ". ";
} */


/* TOC */
.toc > ul{
  padding-left: 0;
}
.article__toc ul { 
  counter-reset: ulItem; list-style: none;
}
.article__toc ul > li:before { 
  content: counters(ulItem, ".") ". "; counter-increment: ulItem; 
}


/* IMG
   ========================================================================== */


figure > img,
p > img{
  /* images can not be bigger than a smaller centered column than the main column */
  margin-left: auto;
  margin-right: auto;
  max-width: calc(100% - calc(8 * var(--lh)));

  /* outline: var(--border); */
}
figure.figure-full > img{
  /* full images take all column */
  max-width: 100%;
}

figure > figcaption{
  /* captions are smaller than main text */
  margin-left: calc(4 * var(--lh));
  margin-right: calc(4 * var(--lh));
}

@media screen and (max-width: 36rem) {

  figure > img{
    /* all images take full width on small devices */
    max-width: 100vw !important;
    margin-left: calc(var(--lh) * -0.5);
    margin-right: calc(var(--lh) * -0.5);
  }

  figure > figcaption{
    /* captions have same width than main text */
    margin-left: 0;
    margin-right: 0;
  }

}


.article__aside,
.article__header,
.article__footer
{
  background: var(--clr-back);
}

/* PRINT
   ========================================================================== */

@media print{

  body.article--long{
    display: grid;
    grid-template-columns: 1fr;
  }
  body.article--long *{
    background: none !important;
  }

  body.article--long .article__aside{
    border: none;
    position: initial;
    height: auto;
    grid-row: 1;
  }

  body.article--long .article__nav,
  body.article--long .article__footer{
    display: none;
  }
  body.article--long .article__header {
    border: var(--border);
    padding: 1rem;
  }
  body.article--long .article__text h2{
    /* break-before: always !important;
    page-break-before: always !important;
    margin-top: 0 !important; */
    /* background-color: red; */
  }
  body.article--long .article__header h1{
    margin-top: 0 !important;
  }

  body.article--long .article__text{
    max-width: 100%;
  }

  body.article--long .pad-big,
  body.article--long .pad-h{
    padding: 0;
  }
  body.article--long .article__content {
    max-width: 100%;
    margin-left: 0;
    margin-top: 0;
    margin-bottom: 0;
  }

  body.article--long .article__content > *{
    max-width: 42rem;
  }
  body.article--long .article__content > h2{
    max-width: 100%;
  }
  figure{
    max-width: 30rem !important;
    margin-left: auto;
  }
  figure > img{
    max-width: 100%;
    max-height: 30rem;
    margin-left: 0;
  }

  /* TODO 
  * link treatment
  * footnotes treatment
  * figcaption treatment
  * page break for title and images
  */

  .local {
    color: currentColor;
  }
  .external::after{
    content: ' (' attr(href) ')';
    font-size: var(--fs-s);
    position: relative;
    color: var(--clr-fade);
  }
}




/* ---- */


.media--only .article__aside{
  position: sticky;
  top: 0;

  display: flex;
}